<?php
// Enable error reporting for debugging
error_reporting(E_ALL);
ini_set('display_errors', 1);

session_start();
date_default_timezone_set('Asia/Kolkata');
$fromdate = date('Y-m-d H:i:s');

// Include database connection and PHPMailer
include("mohini_admin/inc/config.php");
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;

// Collect form data
$fullname = isset($_POST['fullname']) ? trim($_POST['fullname']) : '';
$roomname = isset($_POST['roomname']) ? trim($_POST['roomname']) : '';
$mobile = isset($_POST['mobile']) ? trim($_POST['mobile']) : '';
$email = isset($_POST['email']) ? trim($_POST['email']) : '';
$check_in = isset($_POST['check_in']) ? $_POST['check_in'] : '';
$check_out = isset($_POST['check_out']) ? $_POST['check_out'] : '';
$adult = isset($_POST['adult']) ? $_POST['adult'] : '';
$children = isset($_POST['children']) ? $_POST['children'] : '';
$message = isset($_POST['message']) ? trim($_POST['message']) : '';
$captcha = isset($_POST['captcha']) ? $_POST['captcha'] : '';
$subject = isset($_POST['subject']) ? $_POST['subject'] : 'Booking Inquiry';

// Validate captcha
if (empty($captcha) || $captcha !== $_SESSION["captcha_code"]) {
    echo json_encode(['status' => 'error', 'message' => 'Captcha verification failed.']);
    exit;
}

// Validate mobile number (must be exactly 10 digits)
if (!preg_match('/^\d{10}$/', $mobile)) {
    echo json_encode(['status' => 'error', 'message' => 'Invalid mobile number. It must be 10 digits.']);
    exit;
}

// Validate email format
if (!filter_var($email, FILTER_VALIDATE_EMAIL)) {
    echo json_encode(['status' => 'error', 'message' => 'Invalid email format.']);
    exit;
}

// Validate required fields
if (empty($fullname) || empty($mobile) || empty($email) || empty($check_in) || empty($check_out)) {
    echo json_encode(['status' => 'error', 'message' => 'All fields are required.']);
    exit;
}

// Insert into the database
$sql = "INSERT INTO booking_inquiries (fullname, mobile, email, check_in, check_out, adult, children, message, roomname,created_at) 
        VALUES ('$fullname', '$mobile', '$email', '$check_in', '$check_out', '$adult', '$children', '$message', '$roomname','$fromdate')";

if ($conn->query($sql) === TRUE) {

    // Send email using PHPMailer
    require_once "PHPMailer/PHPMailer.php";
    require_once "PHPMailer/SMTP.php";
    require_once "PHPMailer/Exception.php";

    $mail = new PHPMailer();
    
    $mail->isSMTP();
    $mail->Host = "smtp.gmail.com";
    $mail->SMTPAuth = true;
    $mail->Username = "your-email@gmail.com"; // Replace with your Gmail
    $mail->Password = 'your-app-password'; // Replace with your Gmail app-specific password
    $mail->Port = 465;
    $mail->SMTPSecure = "ssl";

    // Email settings
    $mail->isHTML(true);
    $mail->setFrom($email, $fullname);
    $mail->addAddress("your-receiving-email@example.com"); // Replace with the email where you want to receive the inquiry
    $mail->Subject = $subject;
    $mail->Body = "
        <h2>New Booking Inquiry</h2>
        <p><strong>Name:</strong> $fullname</p>
        <p><strong>Mobile:</strong> $mobile</p>
        <p><strong>Email:</strong> $email</p>
        <p><strong>Room Title:</strong> $roomname</p>
        <p><strong>Check-In Date:</strong> $check_in</p>
        <p><strong>Check-Out Date:</strong> $check_out</p>
        <p><strong>Adults:</strong> $adult</p>
        <p><strong>Children:</strong> $children</p>
        <p><strong>Message:</strong><br>$message</p>
    ";

    // Send email
    if ($mail->send()) {
        echo json_encode(['status' => 'success', 'message' => 'Inquiry submitted and email sent successfully.']);
    } else {
        echo json_encode(['status' => 'error', 'message' => 'Inquiry submitted but email failed to send.']);
    }

} else {
    echo json_encode(['status' => 'error', 'message' => 'Error saving booking inquiry.']);
}

// Close the connection
$conn->close();
?>
