<?php
error_reporting(E_ALL);
ini_set('display_errors', 1);
require_once 'inc/config.php';

// Prepare response array
function compressImage($source, $destination, $fileExtension) {
    try {
        if ($fileExtension == 'jpg' || $fileExtension == 'jpeg') {
            $image = imagecreatefromjpeg($source);
            imagejpeg($image, $destination, 75); // Compress to 75% quality
        } elseif ($fileExtension == 'png') {
            $image = imagecreatefrompng($source);
            imagepng($image, $destination, 6); // Compress level 6
        }
        imagedestroy($image);
        return true;
    } catch (Exception $e) {
        return false;
    }
}

$response = ['status' => 'Error', 'message' => 'Unexpected error occurred.'];


if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    // Fetch action from POST data
    $action = isset($_POST['action']) ? $_POST['action'] : '';

if ($action === 'Create') {
        $room_id = mysqli_real_escape_string($conn, $_POST['room_id']);
        $maxPhotos = 4;

        // Check existing photos
        $sql_check = "SELECT COUNT(*) as total_photos FROM room_photos WHERE room_id = '$room_id'";
        $result_check = mysqli_query($conn, $sql_check);

        if ($result_check) {
            $row_check = mysqli_fetch_assoc($result_check);
            $currentPhotoCount = $row_check['total_photos'];

            if ($currentPhotoCount >= $maxPhotos) {
                $response = ['status' => 'Duplicate', 'message' => 'You can only upload up to 4 images for this room.'];
            } elseif (isset($_FILES['roomphoto'])) {
                $roomphotos = $_FILES['roomphoto'];
                $uploadedFilePaths = [];
                $newPhotoCount = count($roomphotos['name']);

                if ($currentPhotoCount + $newPhotoCount > $maxPhotos) {
                    $response = [
                        'status' => 'Duplicate',
                        'message' => 'You can only upload ' . ($maxPhotos - $currentPhotoCount) . ' more images for this room.',
                    ];
                } else {
                    for ($i = 0; $i < $newPhotoCount; $i++) {
                        if ($roomphotos['error'][$i] == 0) {
                            $fileTmpName = $roomphotos['tmp_name'][$i];
                            $fileName = $roomphotos['name'][$i];
                            $fileExtension = strtolower(pathinfo($fileName, PATHINFO_EXTENSION));

                            if (in_array($fileExtension, ['jpg', 'jpeg', 'png'])) {
                                $uniqueName = uniqid('room_', true) . '.' . $fileExtension;
                                $roomphotoPath = 'uploads/' . $uniqueName;

                                if (compressImage($fileTmpName, $roomphotoPath, $fileExtension)) {
                                    $uploadedFilePaths[] = $roomphotoPath;
                                } else {
                                    $response = ['status' => 'Error', 'message' => 'Error compressing images.'];
                                    break;
                                }
                            }
                        }
                    }

                    foreach ($uploadedFilePaths as $roomphotoPath) {
                        $facility_sql = "INSERT INTO room_photos (room_id, room_photo, status) 
                                         VALUES ('$room_id', '$roomphotoPath', '1')";
                        if (!mysqli_query($conn, $facility_sql)) {
                            $response = ['status' => 'Error', 'message' => 'Database insert error: ' . mysqli_error($conn)];
                            break;
                        }
                    }

                    $response = ['status' => 'Create', 'message' => 'Room photos added successfully.'];
                }
            } else {
                $response = ['status' => 'Error', 'message' => 'No valid images uploaded.'];
            }
        } else {
            $response = ['status' => 'Error', 'message' => 'Error checking existing photos: ' . mysqli_error($conn)];
        }
    }



 elseif ($action === 'Delete') { 
    $id = $_POST['id'];

     // Fetch the image path for the room
    $sql_check = "SELECT room_photo FROM room_photos WHERE id = '$id'";
    $result_check = mysqli_query($conn, $sql_check);

    if ($result_check && mysqli_num_rows($result_check) > 0) {
        $row = mysqli_fetch_assoc($result_check);
        $oldImage = $row['room_photo'];

        // If an image exists, delete it from the server
        if ($oldImage && file_exists($oldImage)) {
            if (!unlink($oldImage)) {
                error_log("Failed to delete image: $oldImage");
            }
        }
    } else {
        echo json_encode([
            'status' => 'Error',
            'message' => 'Room photo not found in the database.',
        ]);
        exit;
    }

    // Delete the room record from the database
    $sql_delete = "DELETE FROM room_photos WHERE id = '$id'"; 
    if (mysqli_query($conn, $sql_delete)) {
        echo json_encode([
            'status' => 'Delete',
            'message' => 'Image deleted successfully.',
        ]);
    } else {
        echo json_encode([
            'status' => 'Error',
            'message' => 'Error deleting the room photo from the database.',
        ]);
    }
    exit;
}

// Function to compress the image


    // Set response header for JSON content
    header('Content-Type: application/json');

    // Return response as JSON
    echo json_encode($response);
    exit;
}
?>
