<?php include('inc/template.php'); ?>

<div class="container-xxl flex-grow-1 container-p-y">
	<button class="btn btn-secondary create-new btn-primary waves-effect waves-light" data-bs-toggle="modal" data-bs-target="#editUser" type="button"><span><i class="ti ti-plus me-sm-1"></i> <span class="d-none d-sm-inline-block">Add New Photo</span></span></button>
	<button class="btn btn-primary" onclick="window.location.href='room_details_list.php'"  type="button"><span><i class="ti ti-arrow-narrow-left me-sm-1"></i> <span class="d-none d-sm-inline-block">Back</span></span></button>
	<div class="modal fade" id="editUser" tabindex="-1" aria-hidden="true">
                <div class="modal-dialog modal-lg modal-simple modal-edit-user">
                  <div class="modal-content">
                    <div class="modal-body">
                      <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                      <div class="text-center mb-6">
                        <h4 class="mb-2">Upload Multiple Photo</h4>
                        </div>
						
                      <form id="editroomphoto" method="post" class="row g-6" enctype="multipart/form-data">
                        <div class="col-12 col-md-12">
                          
                          <input type="file" id="roomphoto" name="roomphoto[]" class="form-control" required accept=".jpg, .jpeg, .png" multiple />

                        </div>
						                       
                        <div class="col-12 text-center">
						<input type="hidden" name="room_id" id="room_id" value="<?php echo isset($_GET['id']) ? $_GET['id'] : ''; ?>" />
						<input type="hidden" name="id" id="id" />
                            <input type="hidden" name="action" id="action" value="Create" />
                          <button type="submit" class="btn btn-primary me-3">Upload</button>
                          
                        </div>
                      </form>
                    </div>
                  </div>
                </div>
              </div>
			<div class="card">
				<?php $roomid = isset($_GET['id']) ? intval($_GET['id']) : 0;
			  $query = "SELECT r.room_title, c.room_cat FROM rooms r JOIN room_categories c ON r.room_cat_id = c.id WHERE r.room_id = ?";
				$stmt = $conn->prepare($query);
				$stmt->bind_param("i", $roomid);
				$stmt->execute();
				$result = $stmt->get_result();
				$row = $result->fetch_assoc();
?>

<h5 class="card-header"><?php echo htmlspecialchars(ucwords($row['room_title'])); ?></h5>

                 <div class="card-datatable table-responsive">
                  <table class="datatables-ajax table">
                    <thead>
                      <tr>
                       <th>Room Photo</th>
					   <!--<th>Status</th>-->
                        <th>Action</th>
                        
                      </tr>
                    </thead>
					 <tbody>
						 <?php
                            $result = mysqli_query($conn, "SELECT * FROM room_photos  ORDER BY id ASC");
                            while ($row = mysqli_fetch_array($result)) {
                            ?>
                            <tr class="showtr">
                                <td><img src="<?php echo htmlspecialchars($row['room_photo']); ?>" width="200" height="100"></td>
								
                               <!-- <td>
                                    <label class="switch">
                                        <input type="checkbox" class="switch-input" value="<?php //echo $row[0]; ?>"
                                               <?php //if ($row['status'] == '1') echo "checked"; ?>
                                               onClick="statusChange(this.value);" />
                                        <span class="switch-toggle-slider">
                                            <span class="switch-on"></span>
                                            <span class="switch-off"></span>
                                        </span>
                                    </label>
                                </td>-->
                                <td>
									
                   				 <button type="button" id="<?php echo $row[0]; ?>" class="btn btn-xs btn-danger delete"><i class="far fa-trash-alt"></i></button>
                                   
                                </td>
								</tr>
                            <?php } ?>
					  </tbody>
                    
                  </table>
                </div>
              </div>
	

</div>
<script>
  $(document).ready(function () {
    // Open modal for creating a new record
    $('#modal_button').click(function () {
      $('#editUser').modal('show'); // Show modal
      $('#editroomcategory')[0].reset(); // Reset form
      $('.modal-title').text("Create New Room Category"); // Set modal title
      $('#action').val('Create'); // Set action to "Create"
      $('#id').val(''); // Clear hidden ID field
    });

    $('#editroomphoto').on('submit', function (event) {
  event.preventDefault(); // Prevent default form submission

  // Create FormData object to handle file uploads and other form data
  var formData = new FormData(this); // 'this' refers to the #editroomphoto form

  $.ajax({
    url: "more_photo_action.php", // The PHP file that will process the form data
    method: "POST",
    data: formData,
    processData: false, // Prevent jQuery from processing the data
    contentType: false, // Prevent jQuery from setting the content type (necessary for file upload)
    success: function (response) {
      console.log(response); // Log the server response for debugging
      $('#editUser').modal('hide');
      // Handle server response
      if (typeof response === "string") {
        try {
          response = JSON.parse(response); // Parse response if it's a JSON string
        } catch (e) {
          console.error("Invalid JSON response:", response);
        }
      }

      if (response.status === 'Create') {
        Swal.fire({
          title: 'Created!',
          text: 'Room photo Created Successfully.',
          icon: 'success',
          confirmButtonText: 'OK'
        }).then(() => {
          location.reload(); // Optionally reload the page to reflect changes
        });
      } else if (response.status === 'Duplicate') {
        Swal.fire({
          title: 'Sorry!',
          text: response.message,
          icon: 'error',
          confirmButtonText: 'OK'
        });
      } else {
        Swal.fire({
          title: 'Error!',
          text: response.message,
          icon: 'error',
          confirmButtonText: 'OK'
        });
      }
    },
    error: function (xhr, status, error) {
      console.error("AJAX error:", status, error); // Log AJAX errors
      Swal.fire({
        title: 'Error!',
        text: 'An error occurred while saving the room photo. Please try again.',
        icon: 'error',
        confirmButtonText: 'OK'
      });
    },
  });

});

// Handle delete action
$(document).on('click', '.delete', function () {
    var id = $(this).attr("id");
    var row = $(this).closest('tr'); // Reference the row for deletion

    // SweetAlert2 confirmation
    Swal.fire({
        title: 'Are you sure?',
        text: 'You are about to delete this room photo.',
        icon: 'warning',
        showCancelButton: true,
        confirmButtonText: 'Yes, delete it!',
        cancelButtonText: 'Cancel',
        reverseButtons: true
    }).then((result) => {
        if (result.isConfirmed) {
            // Proceed with AJAX delete request
            $.ajax({
                url: "more_photo_action.php",
                method: "POST",
                data: { id: id, action: 'Delete' },
                success: function (response) {
                    console.log(response); // Log server response for debugging
                    
                    // Parse response if needed
                    if (typeof response === "string") {
                        response = JSON.parse(response);
                    }

                    if (response.status === 'Delete') {
                        Swal.fire({
                            title: 'Deleted!',
                            text: response.message || 'Room photo deleted successfully.',
                            icon: 'success',
                            confirmButtonText: 'OK'
                        });

                        // Animate row removal
                        row.css('background-color', '#f8d7da').fadeOut(800, function () {
                            $(this).remove();
                        });
                    } else {
                        Swal.fire({
                            title: 'Error!',
                            text: response.message || 'Error deleting room photo.',
                            icon: 'error',
                            confirmButtonText: 'OK'
                        });
                    }
                },
                error: function (xhr, status, error) {
                    console.error('AJAX Error: ', error); // Log error for debugging
                    Swal.fire({
                        title: 'Error!',
                        text: 'Error deleting room photo.',
                        icon: 'error',
                        confirmButtonText: 'OK'
                    });
                },
            });
        }
    });
});

 });
</script>
<?php include('inc/footer.php'); ?>