<?php
error_reporting(E_ALL);
ini_set('display_errors', 1);
require_once 'inc/config.php';

// Prepare response array
$response = [];

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    // Fetch action from POST data
    $action = isset($_POST['action']) ? $_POST['action'] : '';

    // Create action
    if ($action === 'Create') {
        // Get form data
        $room_cat_id = mysqli_real_escape_string($conn, $_POST['room_cat_id']);
        $room_title = mysqli_real_escape_string($conn, $_POST['room_title']);
		$slug = strtolower(trim(preg_replace('/[^A-Za-z0-9-]+/', '-', $room_title), '-'));
        $room_number = mysqli_real_escape_string($conn, $_POST['room_number']);
        $price_per_night = mysqli_real_escape_string($conn, $_POST['price_per_night']);
        $room_description = mysqli_real_escape_string($conn, $_POST['room_description']);
        $room_inclusion = mysqli_real_escape_string($conn, $_POST['room_inclusion']);
        $cancellation_policy = mysqli_real_escape_string($conn, $_POST['cancellation_policy']);
        $facilities = isset($_POST['facilities']) ? $_POST['facilities'] : [];

        // Handle file upload
        if (isset($_FILES['roomphoto']) && $_FILES['roomphoto']['error'] == 0) {
            $roomphoto = $_FILES['roomphoto'];
            $fileExtension = pathinfo($roomphoto['name'], PATHINFO_EXTENSION);
            $uniqueName = uniqid('roomphoto_', true) . '.' . $fileExtension;
            $roomphotoPath = 'uploads/' . $uniqueName;
            move_uploaded_file($roomphoto['tmp_name'], $roomphotoPath);
        } else {
            $roomphotoPath = NULL;
        }

        // Insert room details into the database
        $sql = "INSERT INTO rooms (room_cat_id, room_title, room_number, price_per_night, room_description, room_inclusion, cancellation_policy,slug, room_image)
                VALUES ('$room_cat_id', '$room_title', '$room_number', '$price_per_night', '$room_description', '$room_inclusion', '$cancellation_policy','$slug', " . 
                ($roomphotoPath ? "'$roomphotoPath'" : "NULL") . ")";

        if (mysqli_query($conn, $sql)) {
            $room_id = mysqli_insert_id($conn);

            // Insert selected facilities for the room
            if (!empty($facilities)) {
                foreach ($facilities as $facility_id) {
                    $facility_sql = "INSERT INTO room_facilities (room_id, facility_id) VALUES ('$room_id', '$facility_id')";
                    mysqli_query($conn, $facility_sql);
                }
            }

            $response['status'] = 'Create';
            $response['message'] = 'Room details added successfully.';
        } else {
            $response['status'] = 'Error';
            $response['message'] = 'Error creating room: ' . mysqli_error($conn);
        }
    }

    // Update action
    elseif ($action === 'Update') {
        // Get form data
        $room_id = mysqli_real_escape_string($conn, $_POST['id']);
        $room_cat_id = mysqli_real_escape_string($conn, $_POST['room_cat_id']);
        $room_title = mysqli_real_escape_string($conn, $_POST['room_title']);
		$slug = strtolower(trim(preg_replace('/[^A-Za-z0-9-]+/', '-', $room_title), '-'));
        $room_number = mysqli_real_escape_string($conn, $_POST['room_number']);
        $price_per_night = mysqli_real_escape_string($conn, $_POST['price_per_night']);
        $room_description = mysqli_real_escape_string($conn, $_POST['room_description']);
        $room_inclusion = mysqli_real_escape_string($conn, $_POST['room_inclusion']);
        $cancellation_policy = mysqli_real_escape_string($conn, $_POST['cancellation_policy']);
        $facilities = isset($_POST['facilities']) ? $_POST['facilities'] : [];

        // Handle file upload
        if (isset($_FILES['roomphoto']) && $_FILES['roomphoto']['error'] == 0) {
            $roomphoto = $_FILES['roomphoto'];
            $fileExtension = pathinfo($roomphoto['name'], PATHINFO_EXTENSION);
            $uniqueName = uniqid('roomphoto_', true) . '.' . $fileExtension;
            $roomphotoPath = 'uploads/' . $uniqueName;
            move_uploaded_file($roomphoto['tmp_name'], $roomphotoPath);
        } else {
            $roomphotoPath = NULL;
        }

        // Update the room details with the new photo (if provided)
        if ($roomphotoPath !== NULL) {
            // Delete old image before updating
            $sql_check = "SELECT room_image FROM rooms WHERE room_id = '$room_id'";
            $result_check = mysqli_query($conn, $sql_check);
            if ($result_check && mysqli_num_rows($result_check) > 0) {
                $oldImage = mysqli_fetch_assoc($result_check)['room_image'];
                if ($oldImage && file_exists($oldImage)) {
                    unlink($oldImage);  // Delete old image
                }
            }

            $sql = "UPDATE rooms SET room_cat_id='$room_cat_id', room_title='$room_title', room_number='$room_number',
                    price_per_night='$price_per_night', room_description='$room_description', room_inclusion='$room_inclusion',
                    cancellation_policy='$cancellation_policy', room_image='$roomphotoPath', slug='$slug' WHERE room_id='$room_id'";
        } else {
            $sql = "UPDATE rooms SET room_cat_id='$room_cat_id', room_title='$room_title', room_number='$room_number',
                    price_per_night='$price_per_night', room_description='$room_description', room_inclusion='$room_inclusion',
                    cancellation_policy='$cancellation_policy', slug='$slug' WHERE room_id='$room_id'";
        }

        if (mysqli_query($conn, $sql)) {
            // Delete existing room facilities and add updated ones
            mysqli_query($conn, "DELETE FROM room_facilities WHERE room_id='$room_id'");
            if (!empty($facilities)) {
                foreach ($facilities as $facility_id) {
                    $facility_sql = "INSERT INTO room_facilities (room_id, facility_id) VALUES ('$room_id', '$facility_id')";
                    mysqli_query($conn, $facility_sql);
                }
            }

            $response['status'] = 'Update';
            $response['message'] = 'Room details updated successfully.';
        } else {
            $response['status'] = 'Error';
            $response['message'] = 'Error updating room: ' . mysqli_error($conn);
        }
    }
	elseif ($action === 'Select') {
    $room_id = $_POST['id'];

    // Query the database to select the room details
    $sql = "SELECT * FROM rooms WHERE room_id = '$room_id'";
    $result = mysqli_query($conn, $sql);

    if ($result && mysqli_num_rows($result) > 0) {
        $row = mysqli_fetch_assoc($result);

        // Fetch room facilities
        $facility_sql = "SELECT facility_id FROM room_facilities WHERE room_id = '$room_id'";
        $facility_result = mysqli_query($conn, $facility_sql);
        $facilities = [];
        while ($facility_row = mysqli_fetch_assoc($facility_result)) {
            $facilities[] = $facility_row['facility_id'];
        }

        // Add facilities to the room data
        $row['facilities'] = $facilities;

        // Optional: Check for room image
        $row['room_image'] = $row['room_image'] ? $row['room_image'] : null;
        $response = [
            'status' => 'Select',
            'data' => $row
        ];
    } else {
        $response = [
            'status' => 'Error',
            'message' => 'Room Not Found'
        ];
    }

    }
    // Delete action
    elseif ($action === 'Delete') {
        $room_id = $_POST['id'];

        // Fetch the image path for the room
        $sql_check = "SELECT room_image FROM rooms WHERE room_id = '$room_id'";
        $result_check = mysqli_query($conn, $sql_check);

        if ($result_check && mysqli_num_rows($result_check) > 0) {
            $row = mysqli_fetch_assoc($result_check);
            $oldImage = $row['room_image'];  // Get the old image path

            // If an image exists, delete it from the server
            if ($oldImage && file_exists($oldImage)) {
                unlink($oldImage);  // Delete the image
            }
        }

        // Delete the room record from the database
        $sql_delete = "DELETE FROM rooms WHERE room_id = '$room_id'";
        if (mysqli_query($conn, $sql_delete)) {
            $response['status'] = 'Success';
            $response['message'] = 'Room and image deleted successfully';
        } else {
            // Debugging: output any error that occurs during the query execution
            error_log("MySQL Error: " . mysqli_error($conn));
            $response['status'] = 'Error';
            $response['message'] = 'Error deleting room from database';
        }
    } else {
        $response['status'] = 'Error';
        $response['message'] = 'Invalid request or missing room ID';
    }

    // Set response header for JSON content
    header('Content-Type: application/json');

    // Return response as JSON
    echo json_encode($response);
    exit;
}
?>
