<?php include('inc/template.php'); ?>
 <link rel="stylesheet" href="assets/vendor/libs/quill/editor.css" />
<div class="container-xxl flex-grow-1 container-p-y">
	<div class="d-flex flex-column justify-content-center">
     <h5 class="card-header mb-2">Room Add</h5>
      </div>
	<button class="btn btn-primary" onclick="window.location.href='room_details_list.php'" type="button"><span><i class="ti ti-list me-sm-1"></i> <span class="d-none d-sm-inline-block">Room List</span></span></button>
	<div class="row">
		<!-- Basic Layout -->
		<div class="col-12">
			<div class="card mb-6">
               
                <form class="card-body" method="POST" enctype="multipart/form-data">
    <div class="row g-6">
        <!-- Room Category Dropdown -->
        <div class="col-md-12">
            <label class="form-label" for="room_cat_id">Room Category</label>
            <select class="form-select" id="room_cat_id" required>
                <option value="">Select Room</option>
                <?php
                // Fetch room categories from database
                $sql = "SELECT id, room_cat FROM room_categories WHERE status = '1' ORDER BY room_cat ASC";
                $result = mysqli_query($conn, $sql);
                if (mysqli_num_rows($result) > 0) {
                    while ($row = mysqli_fetch_assoc($result)) {
                        echo "<option value='" . $row['id'] . "'>" . ucwords(strtolower($row['room_cat'])) . "</option>";
                    }
                } else {
                    echo "<option>No rooms available</option>";
                }
                ?>
            </select>
        </div>

        <!-- Room Title -->
        <div class="col-md-12">
            <label class="form-label" for="roomTitle">Room Title</label>
            <input type="text" class="form-control" id="room_title"  required>
        </div>

        <!-- Room No. -->
        <div class="col-md-6">
            <label class="form-label" for="roomNumber">Room No.</label>
            <input type="number" id="room_number" class="form-control" required>
        </div>

        <!-- Price per Night -->
        <div class="col-md-6">
            <label class="form-label" for="pricePerNight">Price per Night</label>
            <input type="number" id="price_per_night"  class="form-control" required pattern="^\d*\.?\d*$" value="<?php echo htmlspecialchars($room['price_per_night']); ?>" title="Please enter a valid number.">


        </div>

        <!-- Room Description -->
        <div class="col-md-12">
            <label class="form-label" for="roomDescription">Room Description</label>
            
               <textarea class="form-control"  id="full-editor" rows="4" required></textarea>
            
        </div>
		<h6>Room Facilities</h6>
        <?php
			$sql1 = "SELECT id, facilityname FROM facilities WHERE status = '1' ORDER BY facilityname ASC";
			$result1 = mysqli_query($conn, $sql1);
			if (mysqli_num_rows($result1) > 0) {
    		while ($row = mysqli_fetch_assoc($result1)) { ?>
        <div class="col-md-3">
            <div class="form-check">
                <input class="form-check-input" type="checkbox" value="<?php echo $row['id']; ?>" id="facility-<?php echo $row['id']; ?>" name="facilities[]" />
                <label class="form-check-label" for="facility-<?php echo $row['id']; ?>">
                    <?php echo htmlspecialchars($row['facilityname']); ?>
                </label>
            </div>
        </div>
    <?php } } else { ?>
    <p>No facilities available</p>
		<?php } ?>

		
        
<!--
        <div class="col-md-12">
            <label class="form-label" for="roomInclusion">Room Inclusion</label>
           
                <textarea class="form-control" name="room_inclusion" id="roomInclusion" rows="4" required></textarea>
            
        </div>

        
        <div class="col-md-12">
            <label class="form-label" for="cancellationPolicy">Cancellation Policy</label>
            
                <textarea class="form-control" name="cancellation_policy" id="cancellationPolicy" rows="4" required></textarea>
            
        </div>
-->
		<div class="col-md-12">
						<label class="form-label" for="multicol-email">Room Image</label>

						 <input  type="file"  id="roomphoto" class="form-control" accept="image/png, image/jpeg, image/jpg" onchange="loadFile(event)"  />
							<script>
  														var loadFile = function(event) {
    													var output = document.getElementById('output');
    													output.src = URL.createObjectURL(event.target.files[0]);
    													output.onload = function() {
      													URL.revokeObjectURL(output.src) // free memory
    													}
  														};
													</script>								

					</div>
					<div class="col-md-3">
						

						<img id="output" src="" height="70" width="70" style="display: none;" />
														

					</div>
    </div>

    <!-- Submit and Cancel Buttons -->
    <div class="pt-6">
        <input type="hidden" id="upd" value="<?php echo isset($_GET['id']) ? $_GET['id'] : ''; ?>">
          <input type="hidden" name="id" id="id">
          <input type="hidden" name="action" id="action" value="<?php echo isset($_GET['id']) ? 'Update' : 'Create'; ?>">
          <button type="submit" class="btn btn-primary me-2"> <?php echo isset($_GET['id']) ? 'Update' : 'Save'; ?> </button>
        <button type="reset" class="btn btn-label-secondary">Cancel</button>
    </div>
</form>

<script>
$(document).ready(function () {
    // Handle form submission
    $('form.card-body').on('submit', function (event) {
        event.preventDefault(); // Prevent default form submission

        // Collect form data
        var formData = {
            room_cat_id: $('#room_cat_id').val(),
            room_title: $('#room_title').val(),
            room_number: $('#room_number').val(),
            price_per_night: $('#price_per_night').val(),
            room_description: $('#full-editor').val(),
            room_inclusion: $('#room_inclusion').val(),
            cancellation_policy: $('#cancellation_policy').val(),
            id: $('#id').val(),
            action: $('#action').val(),
        };

        // Get selected facilities
        formData.facilities = [];
        $('input[name="facilities[]"]:checked').each(function () {
            formData.facilities.push($(this).val());
        });

        // Handle file input separately for FormData
        var file = $('#roomphoto').prop('files')[0];

        // Validate required fields
        if (!formData.room_cat_id || !formData.room_title || !formData.room_number || !formData.price_per_night ) {
            Swal.fire({
                icon: 'error',
                title: 'Error',
                text: 'Please fill out all required fields.',
            });
            return;
        }

        // Validate price
        if (isNaN(formData.price_per_night) || formData.price_per_night <= 0) {
            Swal.fire({
                icon: 'error',
                title: 'Error',
                text: 'Price per night must be a positive number.',
            });
            return;
        }

        // Create FormData object for AJAX
        var formDataObj = new FormData();
        for (const key in formData) {
            if (Array.isArray(formData[key])) {
                formData[key].forEach(value => formDataObj.append(`${key}[]`, value));
            } else {
                formDataObj.append(key, formData[key]);
            }
        }
        if (file) {
            formDataObj.append('roomphoto', file);
        }

        // AJAX request
        $.ajax({
            url: 'room_details_action.php', // Adjust to your server endpoint
            method: 'POST',
            data: formDataObj,
            contentType: false, // Needed for FormData
            processData: false, // Prevent jQuery from automatically processing data
            success: function (response) {
                try {
                    var res = typeof response === 'string' ? JSON.parse(response) : response;

                    if (res.status === 'Create') {
                        Swal.fire({
                            icon: 'success',
                            title: 'Success',
                            text: 'Room details added successfully.',
                        }).then(() => {
                            window.location.href = 'room_details_list.php'; // Redirect to rooms list
                        });
                    } else if (res.status === 'Update') {
                        Swal.fire({
                            icon: 'success',
                            title: 'Success',
                            text: 'Room details updated successfully.',
                        }).then(() => {
                            window.location.href = 'room_details_list.php'; // Redirect to rooms list
                        });
                    } else if (res.status === 'Duplicate') {
                        Swal.fire({
                            icon: 'error',
                            title: 'Duplicate',
                            text: 'Duplicate entry: Room already exists.',
                        });
                    } else if (res.status === 'Error') {
                        Swal.fire({
                            icon: 'error',
                            title: 'Error',
                            text: 'Error: ' + (res.message || 'Unknown error occurred.'),
                        });
                    } else {
                        Swal.fire({
                            icon: 'error',
                            title: 'Error',
                            text: 'Unexpected response: ' + res.status,
                        });
                    }
                } catch (e) {
                    Swal.fire({
                        icon: 'error',
                        title: 'Error',
                        text: 'Error parsing server response.',
                    });
                    console.error('Parsing error:', e, 'Response:', response);
                }
            },
            error: function (xhr) {
                Swal.fire({
                    icon: 'error',
                    title: 'AJAX Error',
                    text: 'An error occurred while submitting the form.',
                });
                console.error('AJAX error:', xhr.responseText);
            },
        });
    });

    // Load form data for updating if `upd` parameter exists
   var upd = $('#upd').val();
if (upd) {
    $.ajax({
        url: 'room_details_action.php', // Adjust to your server endpoint
        method: 'POST',
        data: { id: upd, action: 'Select' },
        dataType: 'json',
        success: function (data) {
            console.log(data); // Log the response for debugging

            if (data.status === 'Select' && data.data) {
                var roomData = data.data;

                // Populate form fields
                $('#room_cat_id').val(roomData.room_cat_id);
                $('#room_title').val(roomData.room_title);
                $('#room_number').val(roomData.room_number);
                $('#price_per_night').val(roomData.price_per_night);
                $('#full-editor').val(roomData.room_description);  // Assuming you're using a text editor like CKEditor
                $('#room_inclusion').val(roomData.room_inclusion);
                $('#cancellation_policy').val(roomData.cancellation_policy);
                $('#id').val(upd);
                $('#action').val('Update');

                // Check facilities and set checkboxes
                if (roomData.facilities && roomData.facilities.length > 0) {
                    roomData.facilities.forEach(function(facility) {
                        $('#facility-' + facility).prop('checked', true);
                    });
                }

                // Show existing room image if available
                if (roomData.room_image) {
                    $('#output').attr('src', roomData.room_image).show();
                } else {
                    $('#output').hide();
                }
            } else {
                Swal.fire({
                    icon: 'error',
                    title: 'Error',
                    text: data.message || 'Room data not found.',
                });
            }
        },
        error: function () {
            Swal.fire({
                icon: 'error',
                title: 'Error',
                text: 'Error fetching data for update.',
            });
        }
    });
}



    // Preview image
    $('#roomphoto').on('change', function (event) {
        var file = event.target.files[0];
        if (file) {
            var reader = new FileReader();
            reader.onload = function (e) {
                $('#output').attr('src', e.target.result).show();
            };
            reader.readAsDataURL(file);
        }
    });
});
</script>

              </div>
		</div>
		<!-- Basic with Icons -->
		
	</div>
	

</div>
 <script src="assets/vendor/libs/quill/katex.js"></script>
    <script src="assets/vendor/libs/quill/quill.js"></script>
<script src="assets/js/forms-editors.js"></script>
<?php include('inc/footer.php'); ?>