<?php include('inc/template.php'); ?>

<div class="container-xxl flex-grow-1 container-p-y">
	<div class="d-flex flex-column justify-content-center">
     <h5 class="card-header mb-2">Room List</h5>
      </div>
	<button class="btn btn-primary" onclick="window.location.href='room_details_add.php'" type="button"><span><i class="ti ti-plus me-sm-1"></i> <span class="d-none d-sm-inline-block">Add New Room</span></span></button>
	
			<div class="card">
                 <div class="card-datatable table-responsive">
<?php
$query = "SELECT r.*, c.room_cat FROM rooms r 
          JOIN room_categories c ON r.room_cat_id = c.id 
          ORDER BY r.room_id ASC";
$result = mysqli_query($conn, $query);
?>

<table class="datatables-ajax table">
    <thead>
        <tr>
            <th>Photo</th>
            <th>Room Category</th>
            <th>Title</th>
            <th>Room No.</th>
            <th>Price</th>
            <th>Facilities</th>
            <th>Status</th>
            <th>Action</th>
        </tr>
    </thead>
    <tbody>
        <?php while ($row = mysqli_fetch_array($result)) { ?>
        <tr class="showtr">
            <td>
                <img src="<?php echo !empty($row['room_image']) ? htmlspecialchars($row['room_image']) : 'assets/img/no-image.jpg'; ?>" 
                     alt="Room Photo" width="50" height="50">
            </td>
            <td><?php echo htmlspecialchars(ucwords($row['room_cat'])); ?></td>
            <td><a href="" data-bs-toggle="modal" 
                        data-bs-target="#modalScrollable" onclick="loadRoomDetails(<?php $row[0]; ?>);"><?php echo htmlspecialchars(ucwords($row['room_title'])); ?></a></td>
            <td><?php echo htmlspecialchars($row['room_number']); ?></td>
            <td><?php echo htmlspecialchars($row['price_per_night']); ?></td>
            <td>
                <?php
                // Fetch facilities for the room
                $room_id = $row['room_id'];
                $facilities_query = "SELECT f.facilityname FROM room_facilities rf 
                                     JOIN facilities f ON rf.facility_id = f.id 
                                     WHERE rf.room_id = $room_id";
                $facilities_result = mysqli_query($conn, $facilities_query);
                $facilities = [];
                while ($facility = mysqli_fetch_assoc($facilities_result)) {
                    $facilities[] = $facility['facilityname'];
                }
                echo htmlspecialchars(implode(', ', $facilities));
                ?>
            </td>
			<td><label class="switch switch-success">
                 <input type="checkbox" class="switch-input" value="<?php echo $row[0]; ?>"
                           <?php $row['is_available'] == 'available' ? 'checked' : ''; ?>
                           onclick="statusChange(<?php echo $row[0]; ?>);">
                 <span class="switch-toggle-slider">
                      <span class="switch-on">
                          <i class="ti ti-check"></i>
                      </span>
					 <span class="switch-off">
						   <i class="ti ti-x"></i>
					 </span>
                 </span>
                 </label>
			</td>
            
            <td>
                <button type="button" class="btn btn-xs btn-primary" title="Add More Photo" onclick="window.location.href='more_photo_room.php?id=<?php echo $row[0]; ?>'">
                   <i class="ti ti-photo me-sm-1" style="font-size: 12px"></i>
                </button>
                <button type="button" class="btn btn-xs btn-warning" 
                        onclick="window.location.href='room_details_add.php?id=<?php echo $row[0]; ?>';">
                    <i class="far fa-edit"></i>
                </button>
                <button type="button" id="<?php echo $row[0]; ?>" class="btn btn-xs btn-danger delete">
                    <i class="far fa-trash-alt"></i>
                </button>
            </td>
        </tr>
        <?php } ?>
    </tbody>
</table>

<!-- Modal -->
<div class="modal fade" id="modalScrollable" tabindex="-1" aria-hidden="true">
    <div class="modal-dialog modal-xl" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body">
                <h6>Room Description</h6>
                <p id="roomDescription" align="justify"></p>
<!--
                <h6>Room Facilities</h6>
                <p id="roomFacilities"></p>
-->
            </div>
        </div>
    </div>
</div>

                </div>
              </div>
	

</div>

<script>
	function loadRoomDetails(roomId) {
    const url = 'fetch_room_details.php'; // Backend script to fetch room details
    fetch(`${url}?room_id=${roomId}`)
        .then(response => response.json())
        .then(data => {
            // Populate modal with room details
            document.getElementById('roomDescription').innerText = data.description || 'No description available.';
            document.getElementById('roomFacilities').innerText = data.facilities || 'No facilities listed.';
        })
        .catch(error => console.error('Error fetching room details:', error));
}
  $(document).ready(function () {
    // Handle delete action
    $(document).on('click', '.delete', function () {
        var id = $(this).attr("id");
        var row = $(this).closest('tr'); // Reference the row for deletion

        // SweetAlert2 confirmation
        Swal.fire({
            title: 'Are you sure?',
            text: 'You are about to delete this room.',
            icon: 'warning',
            showCancelButton: true,
            confirmButtonText: 'Yes, delete it!',
            cancelButtonText: 'Cancel',
            reverseButtons: true
        }).then((result) => {
            if (result.isConfirmed) {
                // Proceed with AJAX delete request
                $.ajax({
                    url: "room_details_action.php",
                    method: "POST",
                    data: { id: id, action: 'Delete' },
                    dataType: 'json',  // Ensure the response is JSON format
                    success: function(response) {
                        console.log(response);  // Debug the response
                        if (response.status === 'Success') {
                            Swal.fire({
                                title: 'Deleted!',
                                text: 'Room Deleted Successfully.',
                                icon: 'success',
                                confirmButtonText: 'OK'
                            });

                            // Animate row removal
                            row.css('background-color', '#f8d7da').fadeOut(800, function () {
                                $(this).remove();
                            });
                        } else {
                            Swal.fire({
                                title: 'Error!',
                                text: response.message || 'There was an error deleting the room.',
                                icon: 'error',
                                confirmButtonText: 'OK'
                            });
                        }
                    },
                    error: function(xhr, status, error) {
                        // Handle AJAX errors (network issues, etc.)
                        Swal.fire({
                            title: 'Error!',
                            text: 'Error deleting room: ' + error,
                            icon: 'error',
                            confirmButtonText: 'OK'
                        });
                    }
                });
            }
        });
    });

    window.statusChange = function (id) {
        $.ajax({
            url: 'room_details_action.php',
            method: 'POST',
            data: { id: id, action: 'StatusChange' },
            success: function (response) {
                // Parse the response manually
                const data = response;  // Directly use the response object as it's already JSON

                if (data.success) {
                    alert(`Status changed to ${data.new_status}`);
                } else {
                    alert(data.message);
                }
            },
            error: function () {
                alert('Error while updating status.');
            }
        });
    };
	  
	
  });
</script>

<?php include('inc/footer.php'); ?>