<?php include('inc/template.php'); ?>

<div class="container-xxl flex-grow-1 container-p-y">
	<button class="btn btn-secondary create-new btn-primary waves-effect waves-light" data-bs-toggle="modal" data-bs-target="#editUser" type="button"><span><i class="ti ti-plus me-sm-1"></i> <span class="d-none d-sm-inline-block">Add New Facilities</span></span></button>
	<div class="modal fade" id="editUser" tabindex="-1" aria-hidden="true">
                <div class="modal-dialog modal-lg modal-simple modal-edit-user">
                  <div class="modal-content">
                    <div class="modal-body">
                      <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                      <div class="text-center mb-6">
                        <h4 class="mb-2" id="modalTitle">New Room Facilities</h4>
                        </div>
                      <form id="editroomfacilities" method="post" class="row g-6" enctype="multipart/form-data">
                        <div class="col-12 col-md-12">
                          <label class="form-label" for="modalEditUserFirstName">Room Facilities</label>
                          <input type="text" id="facilityname" name="facilityname"  class="form-control" required />
                        </div>
						
                        
                        <div class="col-12 col-md-12">
                          <label class="form-label" for="modalEditUserStatus">Status</label>
                          <select id="status" name="status" class="form-select">                        
                            <option value="1">Active</option>
                            <option value="0">Inactive</option>
                            </select>
                        </div>
                       
                        <div class="col-12 text-center">
						<input type="hidden" name="id" id="id" />
                            <input type="hidden" name="action" id="action" value="Create" />
                          <button type="submit" class="btn btn-primary me-3">Submit</button>
                          <button type="reset"  class="btn btn-label-secondary" data-bs-dismiss="modal" aria-label="Close">Cancel</button>
                        </div>
                      </form>
                    </div>
                  </div>
                </div>
              </div>
			<div class="card">
                 <div class="card-datatable table-responsive">
                  <table class="datatables-ajax table">
                    <thead>
                      <tr>
                       <th>Room Facility</th>
						<th>Status</th>
                        <th>Action</th>
                        
                      </tr>
                    </thead>
					 <tbody>
						 <?php
                            $result = mysqli_query($conn, "SELECT * FROM facilities ORDER BY facilityname ASC");
                            while ($row = mysqli_fetch_array($result)) {
                            ?>
                            <tr class="showtr">
                                <td><?php echo htmlspecialchars(ucwords($row['facilityname'])); ?></td>
								 <td>
                                    <label class="switch">
                                        <input type="checkbox" class="switch-input" value="<?php echo $row[0]; ?>"
                                               <?php if ($row['status'] == '1') echo "checked"; ?>
                                               onClick="statusChange(this.value);" />
                                        <span class="switch-toggle-slider">
                                            <span class="switch-on"></span>
                                            <span class="switch-off"></span>
                                        </span>
                                    </label>
                                </td>
                                <td>
									<button type="button" id="<?php echo $row[0]; ?>" class="btn btn-xs btn-warning update"><i class="far fa-edit"></i></button>
                   				 <button type="button" id="<?php echo $row[0]; ?>" class="btn btn-xs btn-danger delete"><i class="far fa-trash-alt"></i></button>
                                   
                                </td>
								</tr>
                            <?php } ?>
					  </tbody>
                    
                  </table>
                </div>
              </div>
	

</div>


<script>
  $(document).ready(function () {
    // Open modal for creating a new record
    $('#modal_button').click(function () {
      $('#editUser').modal('show'); // Show modal
      $('#editroomfacilities')[0].reset(); // Reset form
      $('#modalTitle').text("Create New Room Facilities");
      $('#action').val('Create'); // Set action to "Create"
      $('#id').val(''); // Clear hidden ID field
    });

    // Open modal for updating a record
    $(document).on('click', '.update', function () {
      var id = $(this).attr("id");
      $.ajax({
        url: "room_facilities_action.php",
        method: "POST",
        data: { id: id, action: 'Select' },
        dataType: "json",
        success: function (data) {
          $('#editUser').modal('show'); // Show modal
          $('#facilityname').val(data.facilityname); // Populate room Facilities
          $('#status').val(data.status); // Populate status
          $('#modalTitle').text("Update Room Facilities");
          $('#action').val('Update'); // Set action to "Update"
          $('#id').val(id); // Set hidden ID field
        },
        error: function () {
          toastr.error('Error fetching room facilities details.');
        },
      });
    });

    // Handle form submission for Create/Update
    $('#editroomfacilities').on('submit', function (event) {
  event.preventDefault();

  // Get form data
  var formData = {
    id: $('#id').val(),
    facilityname: $('#facilityname').val(),
    status: $('#status').val(),
    action: $('#action').val(),
  };

  // Validate required fields
  if (formData.facilityname !== '') {
    // AJAX request
    $.ajax({
      url: "room_facilities_action.php",
      method: "POST",
      data: formData,
      success: function (response) {
        $('#editUser').modal('hide'); // Hide modal after submission

        // Show SweetAlert response based on server's response
        if (response === 'Create') {
          Swal.fire({
            title: 'Created!',
            text: 'Room Facilities Created Successfully.',
            icon: 'success',
            confirmButtonText: 'OK'
          });
        } else if (response === 'Update') {
          Swal.fire({
            title: 'Updated!',
            text: 'Room Facilities Updated Successfully.',
            icon: 'success',
            confirmButtonText: 'OK'
          });
        } else if (response === 'Duplicate') {
          Swal.fire({
            title: 'Duplicate!',
            text: 'Room Facilities already exists.',
            icon: 'error',
            confirmButtonText: 'OK'
          });
        } else {
          Swal.fire({
            title: 'Error!',
            text: 'Error saving room facilities.',
            icon: 'error',
            confirmButtonText: 'OK'
          });
        }

        setTimeout(function () {
          location.reload(); 
        }, 1500); 
      },
      error: function () {
        Swal.fire({
          title: 'Error!',
          text: 'Error saving room facilities.',
          icon: 'error',
          confirmButtonText: 'OK'
        });
      },
    });
  } else {
    // If any required fields are empty, show SweetAlert error message
    Swal.fire({
      title: 'Error!',
      text: 'All required fields must be filled.',
      icon: 'error',
      confirmButtonText: 'OK'
    });
  }
});


    // Handle delete action
    $(document).on('click', '.delete', function () {
    var id = $(this).attr("id");
    var row = $(this).closest('tr'); // Reference the row for deletion

    // SweetAlert2 confirmation
    Swal.fire({
        title: 'Are you sure?',
        text: 'You are about to delete this room facilities.',
        icon: 'warning',
        showCancelButton: true,
        confirmButtonText: 'Yes, delete it!',
        cancelButtonText: 'Cancel',
        reverseButtons: true
    }).then((result) => {
        if (result.isConfirmed) {
            // Proceed with AJAX delete request
            $.ajax({
                url: "room_facilities_action.php",
                method: "POST",
                data: { id: id, action: 'Delete' },
                success: function (response) {
                    if (response === 'Delete') {
                        Swal.fire({
                            title: 'Deleted!',
                            text: 'Room Facilities Deleted Successfully.',
                            icon: 'success',
                            confirmButtonText: 'OK'
                        });

                        // Animate row removal
                        row.css('background-color', '#f8d7da').fadeOut(800, function () {
                            $(this).remove();
                        });
                    } else {
                        Swal.fire({
                            title: 'Error!',
                            text: 'There was an error deleting the room Facilities.',
                            icon: 'error',
                            confirmButtonText: 'OK'
                        });
                    }
                },
                error: function () {
                    Swal.fire({
                        title: 'Error!',
                        text: 'Error deleting room facilities.',
                        icon: 'error',
                        confirmButtonText: 'OK'
                    });
                },
            });
        }
    });
});
window.statusChange = function (id) {
    $.ajax({
        url: 'room_facilities_action.php',
        method: 'POST',
        data: { id: id, action: 'StatusChange' },
        success: function (response) {
            // Parse the response manually
            const data = JSON.parse(response);

            if (data.success) {
                alert(`Status changed to ${data.new_status}`);
            } else {
                alert(data.message);
            }
        },
        error: function () {
            alert('Error while updating status.');
        }
    });
};

  });
</script>
<?php include('inc/footer.php'); ?>