<?php
error_reporting(E_ALL);
ini_set('display_errors', 1);
require_once 'inc/config.php';

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $action = $_POST['action'];

    // Handle Create action
    if ($action === 'Create') {
        $facilityname = $_POST['facilityname'];
         $status = $_POST['status'];

        // Check if the room category already exists
        $checkQuery = "SELECT * FROM facilities WHERE facilityname = ?";
        $stmt = $conn->prepare($checkQuery);
        $stmt->bind_param('s', $facilityname);
        $stmt->execute();
        $result = $stmt->get_result();

        if ($result->num_rows > 0) {
            echo 'Duplicate';
        } else {
            // Insert new record
            $insertQuery = "INSERT INTO facilities (facilityname, status) VALUES (?, ?)";
            $stmt = $conn->prepare($insertQuery);
            $stmt->bind_param('ss', $facilityname,$status);

            if ($stmt->execute()) {
                echo 'Create';
            } else {
                echo 'Error';
            }
        }
    }

    // Handle Update action
    if ($action === 'Update') {
        $id = $_POST['id'];
        $facilityname = $_POST['facilityname'];
        $status = $_POST['status'];

        // Update the record
        $updateQuery = "UPDATE facilities SET facilityname = ?, status = ? WHERE id = ?";
        $stmt = $conn->prepare($updateQuery);
        $stmt->bind_param('ssi', $facilityname, $status, $id);

        if ($stmt->execute()) {
            echo 'Update';
        } else {
            echo 'Error';
        }
    }

    // Handle Select action
    if ($action === 'Select') {
        $id = $_POST['id'];

        // Fetch record details
        $selectQuery = "SELECT * FROM facilities WHERE id = ?";
        $stmt = $conn->prepare($selectQuery);
        $stmt->bind_param('i', $id);
        $stmt->execute();
        $result = $stmt->get_result();

        if ($result->num_rows > 0) {
            $row = $result->fetch_assoc();
            echo json_encode($row); // Return record as JSON
        } else {
            echo 'Error';
        }
    }
	
	if ($action === 'StatusChange') {
    
        $id = $_POST['id'];
        $sql_select = "SELECT status FROM facilities WHERE id = $id";
        $result_select = mysqli_query($conn, $sql_select);

        if (mysqli_num_rows($result_select) > 0) {
            $row = mysqli_fetch_assoc($result_select);
            $new_status = $row['status'] == 1 ? 0 : 1;
            $sql_update = "UPDATE facilities SET status = '$new_status' WHERE id = $id";

            if (mysqli_query($conn, $sql_update)) {
                $status_text = $new_status == 1 ? 'Active' : 'Inactive';
                echo json_encode([
                    'success' => true,
                    'message' => 'Status Updated',
                    'new_status' => $status_text,
                ]);
            } else {
                echo json_encode([
                    'success' => false,
                    'message' => 'Error while updating status.',
                ]);
            }
        } else {
            echo json_encode([
                'success' => false,
                'message' => 'Record not found.',
            ]);
        }
    
}



    // Handle Delete action
    if ($action === 'Delete') {
        $id = $_POST['id'];

        // Delete the record
        $deleteQuery = "DELETE FROM facilities WHERE id = ?";
        $stmt = $conn->prepare($deleteQuery);
        $stmt->bind_param('i', $id);

        if ($stmt->execute()) {
            echo 'Delete';
        } else {
            echo 'Error';
        }
    }
}
?>
